package generator

import "testing"

func TestInterfaceBasic (test *testing.T) {
testString (test,
`%Doer = type { ptr, ptr }
%T = type i64
define void @main() {
0:
	%1 = alloca %Doer
	%2 = getelementptr %Doer, ptr %1, i32 0, i32 0
	%3 = alloca %T
	store ptr %3, ptr %2
	%4 = getelementptr %Doer, ptr %1, i32 0, i32 1
	store ptr @T.do, ptr %4
	%5 = load %Doer, ptr %1
	%6 = alloca %Doer
	store %Doer %5, ptr %6
	%7 = getelementptr %Doer, ptr %6, i32 0, i32 1
	%8 = getelementptr %Doer, ptr %6, i32 0, i32 0
	%9 = load ptr, ptr %8
	%10 = load ptr, ptr %7
	call void %10(ptr %9)
	ret void
}
define void @T.do(ptr %this) {
0:
	%1 = alloca ptr
	store ptr %this, ptr %1
	ret void
}
`,
`
Doer: ([do])
T: Int
T.[do] = { }

[main] = {
	if:Doer = x:T
	if.[do]
}
`)
}

func TestInterfaceIntegerReturn (test *testing.T) {
testString (test,
`%Number = type i64
%Numbered = type { ptr, ptr }
define i64 @main() {
0:
	%1 = alloca %Number
	store i64 5, ptr %1
	%2 = alloca %Numbered
	%3 = getelementptr %Numbered, ptr %2, i32 0, i32 0
	store ptr %1, ptr %3
	%4 = getelementptr %Numbered, ptr %2, i32 0, i32 1
	store ptr @Number.number, ptr %4
	%5 = load %Numbered, ptr %2
	%6 = alloca %Numbered
	store %Numbered %5, ptr %6
	%7 = getelementptr %Numbered, ptr %6, i32 0, i32 1
	%8 = getelementptr %Numbered, ptr %6, i32 0, i32 0
	%9 = load ptr, ptr %8
	%10 = load ptr, ptr %7
	%11 = call i64 %10(ptr %9)
	ret i64 %11
}
define i64 @Number.number(ptr %this) {
0:
	%1 = alloca ptr
	store ptr %this, ptr %1
	%2 = load ptr, ptr %1
	%3 = load i64, ptr %2
	ret i64 %3
}
`,
`
Numbered: ([number]: Int)
Number: Int
Number.[number]: Int = [.this]

[main]: Int = {
	num:Number = 5
	if:Numbered = num
	if.[number]
}
`)
}
